bierlijst/urls.py
from django.urls import path

from . import views

app_name = 'bierlijst'
urlpatterns = [
    path('', views.index, name='index'),
    path('api', views.api, name='api'),
    # ex: /bierlijst/5/drink/
    path('<int:resident_id>/drink/', views.drink, name='drink'),
    path('<int:resident_id>/drink_add/', views.drink_add, name='drink_add'),
    
    path('<int:resident_id>/crate/', views.crate, name='crate'),
    path('<int:resident_id>/crate_add/', views.crate_add, name='crate_add'),
    
    path('<int:resident_id>/personalTransactions/', views.personalTransactions, name='personalTransactions'),
    path('<int:resident_id>/personalTransactions_action/', views.personalTransactions_action, name='personalTransactions_action'),
]

calslaan/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('bierlijst/', include('bierlijst.urls')),
    path('admin/', admin.site.urls),
]

bierlijst/models.py
from django.db import models

# Create your models here.
class Resident(models.Model):
	name = models.CharField(max_length=200)
	beers = models.IntegerField(default=0)
	crates = models.IntegerField(default=0)
	singleBeerBuy = models.IntegerField(default=0)
	statiegeld = models.IntegerField(default=0)
	active = models.BooleanField(default=True)
	
	def __str__(self):
		ret = self.name
		return ret

class BeerLog(models.Model):
    resident = models.ForeignKey(Resident, on_delete=models.CASCADE)
    drink_date = models.DateTimeField('date drank')
    quantity = models.IntegerField(default=0)

class SingleBeerBuyLog(models.Model):
    resident = models.ForeignKey(Resident, on_delete=models.CASCADE)
    buy_date = models.DateTimeField('date the beer was bought')
    quantity = models.IntegerField(default=0)
    

class CrateLog(models.Model):
    resident = models.ForeignKey(Resident, on_delete=models.CASCADE)
    buy_date = models.DateTimeField('date the crate was bought')
    quantity = models.IntegerField(default=0)


class StatiegeldLog(models.Model):
    resident = models.ForeignKey(Resident, on_delete=models.CASCADE)
    buy_date = models.DateTimeField('Entry date')
    money = models.IntegerField(default=0)
    
    
    
    
    
# Banking model.
class BankStatus(models.Model):
	status_type = models.CharField(max_length=200)
	status_value = models.IntegerField(default=0)


class BankLog(models.Model):
	resident_user = models.IntegerField(default=0)
	user_identifier = models.CharField(default='', max_length=200)
	resident_affected = models.IntegerField(default=0)
	transaction_comment = models.CharField(max_length=500)
	bank_balance_change = models.IntegerField(default=0)

bierlijst/views/api.py
from django.shortcuts import render
from django.http import HttpResponse, HttpResponseRedirect
from django.utils import timezone

import logging
import math

from ..models import Resident, BeerLog, BankStatus

import json

logger = logging.getLogger('calslaan.bierlijst.api')

def api(request):
	jdata = {}
	try:
		jdata = json.loads(request.body)
		print("Request string : %s ." % request.body)
	except:
		pass
	
	jresponse = {
		'response' : 'ok',
		'data' : [ 
		]
	}
	
	if('request' in jdata.keys()):
		if(jdata['request'] == 'add'):
			if(
				('id' in jdata.keys())
				and ('add_beers' in jdata.keys())
			):
				resident_id = 0
				beers = 0
				try:
					resident_id = int(jdata['id'])
					beers = int(jdata['add_beers'])
				except:
					pass
				
				if(
					(resident_id > 0)
					and (beers > 0)
				):
					r = 0
					try:
						r = Resident.objects.get(id=resident_id)
					except:
						pass
					if(r):
						r.beers += beers
						bl = r.beerlog_set.create(drink_date=timezone.now(), quantity=beers)
						r.save()
	
	resident_list = Resident.objects.filter(active=1).order_by('-beers')
	for resident in resident_list:
		new_data = {
			'id'       : resident.id,
			'name'     : resident.name,
			'beers'    : resident.beers,
			'status'   : int( math.floor(((resident.crates * 24) + resident.singleBeerBuy - resident.beers) / 24) )
		}
		jresponse['data'].append(new_data)
	
	
	return HttpResponse(json.dumps(jresponse)) 

bierlijst/views/banking.py
from django.shortcuts import render
from django.http import HttpResponse, HttpResponseRedirect
from django.urls import reverse
from django.utils import timezone

import logging
import math

from ..models import Resident, BeerLog, BankStatus, BankLog

from decimal import Decimal

import json

logger = logging.getLogger('calslaan.bierlijst.banking') 

def personalTransactions(request, resident_id):
	r = Resident.objects.get(id=resident_id)
	bank_balance_field = BankStatus.objects.get(status_type='balance')
	r.statiegeld /= 100
	context = {'resident': r, 'bank_balance': (bank_balance_field.status_value) / 100}
	return render(request, 'bierlijst/personalTransactions.html', context)


def personalTransactions_action(request, resident_id):

	r = Resident.objects.get(id=resident_id)
	bank_balance_field = BankStatus.objects.get(status_type='balance')
	bank_balance = bank_balance_field.status_value
	amount = 0
	try:
		amount = int(float(request.POST['amount']) * 100)
	except:
		pass
	txtype = request.POST['txtype']

	if(amount > 0):
		if(txtype == 'deposit'):
			r.statiegeld += amount
			bank_balance_field.status_value += amount
			sgl = r.statiegeldlog_set.create(buy_date=timezone.now(), money=(amount))
			bl = BankLog(
				resident_user=resident_id,
				user_identifier='mac_detection_not_implemented',
				resident_affected=resident_id,
				transaction_comment='%s : %s deposit %.2f into the bank.' % (r.name, r.name, (amount / 100)),
				bank_balance_change = amount
			)
			bl.save()
		elif(txtype == 'withdraw'):
			print("Balance : %d, amount : %d." % (bank_balance, amount))
			if(bank_balance >= amount):
				r.statiegeld -= amount
				bank_balance_field.status_value -= amount
				sgl = r.statiegeldlog_set.create(buy_date=timezone.now(), money=(-amount))
				bl = BankLog(
					resident_user=resident_id,
					user_identifier='mac_detection_not_implemented',
					resident_affected=resident_id,
					transaction_comment='%s : %s withdrew %.2f from the bank.' % (r.name, r.name, (amount / 100)),
					bank_balance_change = -amount
				)
				bl.save()
		bank_balance_field.save()
		r.save()
		
		return HttpResponseRedirect(reverse('bierlijst:index'))

bierlijst/views/general.py
from django.shortcuts import render
from django.http import HttpResponse, HttpResponseRedirect
from django.urls import reverse
from django.utils import timezone

import logging
import math

from ..models import Resident, BeerLog, BankStatus

from decimal import Decimal

import json

logger = logging.getLogger('calslaan.bierlijst.general')


# Create your views here.

def index(request):
	resident_list = Resident.objects.filter(active=1).order_by('-beers')
	for r in resident_list:
		r.statiegeld /= 100
		r.crates = int( math.floor(((r.crates * 24) + r.singleBeerBuy - r.beers) / 24) )
	
	bank_balance = BankStatus.objects.get(status_type='balance')
	context = {'resident_list': resident_list, 'bank_balance': (bank_balance.status_value) / 100}
	return render(request, 'bierlijst/index.html', context)

def drink(request, resident_id):
	r = Resident.objects.get(id=resident_id)
	context = {'resident': r}
	return render(request, 'bierlijst/drink.html', context)

def drink_add(request, resident_id):
	r = Resident.objects.get(id=resident_id)
	count_beer = int(request.POST['count'])
	if(count_beer > 0):
		r.beers += count_beer
		bl = r.beerlog_set.create(drink_date=timezone.now(), quantity=count_beer)
		r.save()
	return HttpResponseRedirect(reverse('bierlijst:index'))



def crate(request, resident_id):
	r = Resident.objects.get(id=resident_id)
	context = {'resident': r}
	return render(request, 'bierlijst/crate.html', context)

def crate_add(request, resident_id):
	r = Resident.objects.get(id=resident_id)
	count_crate = 0
	try:
		count_crate = int(request.POST['crates'])
	except:
		pass
	sg_put = 0
	try:
		sg_put = int(count_crate * 390)
	except:
		pass
	sg_rxd = 0
	try:
		sg_rxd = -int(Decimal(request.POST['sg_rxd']) * 390)
	except:
		pass
	count_beer = 0
	try:
		count_beer = int(request.POST['beers_bought'])
	except:
		pass
	if ( (count_crate >= 0) and (sg_put >= 0) and (sg_rxd <= 0) and (count_beer >= 0) ):
		r.crates += count_crate
		r.statiegeld += sg_put
		r.statiegeld += sg_rxd
		r.singleBeerBuy += count_beer
		crl = r.cratelog_set.create(buy_date=timezone.now(), quantity=count_crate)
		sgpl = r.statiegeldlog_set.create(buy_date=timezone.now(), money=sg_put)
		sgrl = r.statiegeldlog_set.create(buy_date=timezone.now(), money=sg_rxd)
		sbbl = r.singlebeerbuylog_set.create(buy_date=timezone.now(), quantity=count_beer)
		r.save()
	return HttpResponseRedirect(reverse('bierlijst:index')) 

bierlijst/templates/bierlijst/crate.html
<!DOCTYPE html>
<html>
<head>
	<title>Bierlijst</title>
	{% load static %}
	
	<script type="text/javascript" src="{% static 'bierlijst/jquery/jquery.mobile-1.4.5.min.js' %}"></script>
	
	
	<meta name="viewport" content="width=device-width, initial-scale=1"> 
	<link rel="stylesheet" href="{% static 'bierlijst/jquery/jquery.mobile-1.4.5.min.css' %}" />
	<script type="text/javascript" src="{% static 'bierlijst/jquery/jquery.min.js' %}"></script>
	
	
	<link rel="stylesheet" type="text/css" href="{% static 'bierlijst/table.css' %}">
</head>
<body>

	<h1>{{ resident.name }}</h1>
	
	<form style="text-align:center" action="{% url 'bierlijst:crate_add' resident.id %}" method="POST" id="add_form">
		<table>
			<tr><td><label for="number-1">Crates (multiplies by €3,90 for statiegeld) :</label></td></tr>
			<tr><td><input type="number" data-clear-btn="false" name="crates" id="number-1" value="0"></td></tr>
			<tr><td>&nbsp;<br/></td></tr>
			
			<tr><td><label for="number-3">Statiegeld received (multiplies number by €3,90) :</label></td></tr>
			<tr><td><input type="number" data-clear-btn="false" name="sg_rxd" id="number-3" value="0"></td></tr>
			<tr><td>&nbsp;<br/></td></tr>
			
			<tr><td><label for="number-4">Beers (WARNING : Only if you want to just add beer without statiegeld) :</label></td></tr>
			<tr><td><input type="number" data-clear-btn="false" name="beers_bought" id="number-4" value="0"></td></tr>
		</table>
	</form>
	
	<br>&nbsp;<br>&nbsp;
	
	<button class="ui-btn" onclick="document.getElementById('add_form').submit();">Add</button>
	
	<br>&nbsp;
	
	<button class="ui-btn ui-icon-delete ui-btn-icon-left ui-shadow-icon ui-btn-b" onclick="location.href = {% url 'bierlijst:index' %}">Go back</button>
</body>
</html>

bierlijst/templates/bierlijst/drink.html
<!DOCTYPE html>
<html>
<head>
	<title>Bierlijst</title>
	{% load static %}
	
	<script type="text/javascript" src="{% static 'bierlijst/jquery/jquery.mobile-1.4.5.min.js' %}"></script>
	
	
	<meta name="viewport" content="width=device-width, initial-scale=1"> 
	<link rel="stylesheet" href="{% static 'bierlijst/jquery/jquery.mobile-1.4.5.min.css' %}" />
	<script type="text/javascript" src="{% static 'bierlijst/jquery/jquery.min.js' %}"></script>
	
	
	<link rel="stylesheet" type="text/css" href="{% static 'bierlijst/table.css' %}">
</head>
<body>

	<h1>{{ resident.name }}</h1>
	
	<form style="text-align:center" action="{% url 'bierlijst:drink_add' resident.id %}" method="POST" id="count_form">
		<label for="number-1">Number :</label>
		<input type="number" data-clear-btn="false" name="count" id="number-1" value="1">
	</form>
	
	<br>&nbsp;<br>&nbsp;
	
	<button class="ui-btn" onclick="document.getElementById('count_form').submit();">Add</button>
	
	<br>&nbsp;
	
	<button class="ui-btn ui-icon-delete ui-btn-icon-left ui-shadow-icon ui-btn-b" onclick="location.href = {% url 'bierlijst:index' %}">Go back</button>
</body>
</html>

bierlijst/templates/bierlijst/index.html
<!DOCTYPE html>
<html>
<head>
	<title>Bierlijst</title>
	{% load static %}
	<script type="text/javascript" src="{% static 'bierlijst/jquery/jquery.mobile-1.4.5.min.js' %}"></script>
	
	<meta name="viewport" content="width=device-width, initial-scale=1"> 
	<link rel="stylesheet" type="text/css" href="{% static 'bierlijst/table.css' %}">
	<link rel="stylesheet" href="{% static 'bierlijst/jquery/jquery.mobile-1.4.5.min.css' %}" />
	<script type="text/javascript" src="{% static 'bierlijst/jquery/jquery.min.js' %}"></script>
</head>
<body>

	<h1>Bierlijst</h1>
	
		{% if resident_list %}
			<table class="container">
				<thead>
					<tr>
						<th><h1>Name</h1></th>
						<th style="width: 20%;"><h1>Bier<br/>[Click to drink]</h1></th>
						<th style="width: 20%;"><h1>Crates<br/>[Click when you buy]</h1></th>
						<th style="width: 20%;"><h1>Credit</h1></th>
					</tr>
				</thead>
				<tbody>
			{% for resident in resident_list %}
				<tr>
					<td>{{ resident.name }}</td>
					<td onclick="location.href = '/bierlijst/{{ resident.id }}/drink/'">{{ resident.beers }}</td>
					
					<td onclick="location.href = '/bierlijst/{{ resident.id }}/crate/'">
					{% if resident.crates < 0 %}
						<span class="red">{{ resident.crates }}</span>
					{% else %}
						<span class="green">{{ resident.crates }}</span>
					{% endif %}
					</td>
					
					{% if resident.statiegeld < 0 %}
						<td class="red" onclick="location.href = '/bierlijst/{{ resident.id }}/personalTransactions/'">&euro; {{ resident.statiegeld }}</td>
					{% else %}
						<td class="green" onclick="location.href = '/bierlijst/{{ resident.id }}/personalTransactions/'">&euro; {{ resident.statiegeld }}</td>
					{% endif %}
				</tr>
			{% endfor %}
			</tbody>
			</table>
		{% else %}
			<p>No residents in the house.</p>
		{% endif %}
		<button class="ui-btn">
		Bank balance : 
		{% if bank_balance < 0 %}
			<span class="red">&euro; {{ bank_balance }}</span>
		{% else %}
			<span class="green">&euro; {{ bank_balance }}</span>
		{% endif %}
		</button>

</body>
</html>

bierlijst/templates/bierlijst/personalTransactions.html
<!DOCTYPE html>
<html>
<head>
	<title>Bierlijst</title>
	{% load static %}
	
	<script type="text/javascript" src="{% static 'bierlijst/jquery/jquery.mobile-1.4.5.min.js' %}"></script>
	
	
	<meta name="viewport" content="width=device-width, initial-scale=1"> 
	<link rel="stylesheet" href="{% static 'bierlijst/jquery/jquery.mobile-1.4.5.min.css' %}" />
	<script type="text/javascript" src="{% static 'bierlijst/jquery/jquery.min.js' %}"></script>
	
	
	<link rel="stylesheet" type="text/css" href="{% static 'bierlijst/table.css' %}">
</head>
<body>

	<h1>{{ resident.name }}</h1>
	
	<center>
		Statiegeld : 
		{% if resident.statiegeld < 0 %}
			<span class="red">&euro; {{ resident.statiegeld }}</span>
		{% else %}
			<span class="green">&euro; {{ resident.statiegeld }}</span>
		{% endif %}<br>
		Bank balance : 
			<span class="green">&euro; {{ bank_balance }}</span>
	</center>
	<br>
	<form style="text-align:center" action="{% url 'bierlijst:personalTransactions_action' resident.id %}" method="POST" id="amount_form">
		<label for="number-1">Amount &euro; :</label>
		<input type="number" data-clear-btn="false" name="amount" id="number-1" value="0.0">
		<input type="hidden" name="txtype" id="txtype" value="-">
	</form>
	
	<br>&nbsp;<br>&nbsp;
	
	<button class="ui-btn" onclick="document.getElementById('txtype').value = 'deposit';document.getElementById('amount_form').submit();">Deposit</button>
	
	<br>&nbsp;
	
	<button class="ui-btn" onclick="if({{ bank_balance }} >= document.getElementById('number-1').value) {document.getElementById('txtype').value = 'withdraw';document.getElementById('amount_form').submit();} else {alert('Insufficient bank balance.');}">Withdraw</button>
	
	
	<br>&nbsp;<br>&nbsp;
	
	<button class="ui-btn ui-icon-delete ui-btn-icon-left ui-shadow-icon ui-btn-b" onclick="location.href = {% url 'bierlijst:index' %}">Go back</button>
</body>
</html>